
#include <stdlib.mqh>
#include <stderror.mqh>

extern double Lots = 0.1;
extern double StopLoss = 1000;
extern double TakeProfit = 30;
extern double TrailingStop = 0;
extern double MagicNumber = 123456;

extern double depo = 1000;
extern double swpr = -5;
extern double bwpr = -95;
extern double zswpr = -40;
extern double zbwpr = -60;
extern double dper = 96;
extern double kh = 3;
extern double stopA = 65;
extern double stopB = 35;

double mlot = 0;
double s = 0;
double b = 0;
double summa = 0;
double bsum = 0;
double ssum = 0;
double pros = 0;
double wprone = 0;
double wprnul = 0;
double FreeMargin = 0;
double prof = 0;
double MinL = 0;
double MaxH = 0;
double ccione = 0;
double ccinul = 0;
double stop = 0;

string dw = "";
string AN = "";
bool   ft = true;
bool   fr = true;

int DWeek;
int STime;
int cnt;
int blok = 1;
int hblok;
int plb;
int pls;
int pl;
int sig;
int ttr;
int pflag;
int risk; 
int number;
int tiket;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   bool mode=IsDemo();
   if (!mode) {Comment("   "); return(0);}
   if (AccountNumber()!=758445) {Comment("    758445"); return(0);}
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

 if (Bars<150) return(0);
 
 number=AccountNumber();

 DWeek=DayOfWeek(); 

 STime=Hour();
 
 FreeMargin = AccountFreeMargin(); 
 
 MaxH=0;MinL=1000;
 
 for (cnt=1;cnt<=dper;cnt++)
 {
  if(MaxH<High[cnt]) MaxH=High[cnt];
  if(MinL>Low[cnt]) MinL=Low[cnt];
 }
 
  if (STime==0 || ft) { ObjectDelete("MaxH");ObjectDelete("MinL");ft=false; } 
 
  if (ObjectFind("MaxH")==-1) {
      ObjectCreate("MaxH", 1, 0, Time[20], MaxH, 0, MaxH, 0, 0);
      Print(ErrorDescription(GetLastError()));
      ObjectSet("MaxH", OBJPROP_COLOR, Magenta);
      ObjectSet("MaxH", OBJPROP_STYLE, 2); }
 
  if (ObjectFind("MinL")==-1) {
      ObjectCreate("MinL", 1, 0, Time[20], MinL, 0, MinL, 0, 0);
      Print(ErrorDescription(GetLastError()));
      ObjectSet("MinL", OBJPROP_COLOR, Gold);
      ObjectSet("MinL", OBJPROP_STYLE, 2); }
 
  mlot = Lots;
     
  if (Close[0]<MaxH && Close[0]>MinL) stop=stopA; else stop=stopB;  

  wprone=iCustom(NULL,0,"ExtraWPR",0,1); wprone=MathRound(wprone);
  wprnul=iCustom(NULL,0,"ExtraWPR",0,0); wprnul=MathRound(wprnul);
 
  ccione=iCCI(NULL,0,21,Close[0],1);ccione=MathRound(ccione);
  ccinul=iCCI(NULL,0,21,Close[0],0);ccinul=MathRound(ccinul);

 s=0;b=0;summa=0;bsum=0;ssum=0;
 ttr=OrdersTotal()-1;
 for(cnt=ttr;cnt>=0;cnt--)
  {
   if (OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
    {
     if(OrderType()==OP_SELL && OrderSymbol()==Symbol())
      { 
       if(OrderLots()>=kh*mlot) hblok=1;
       ssum=ssum+OrderProfit()+OrderSwap();s=s+1;    
      } 
     if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
      { 
       if(OrderLots()>=kh*mlot) hblok=1;
       bsum=bsum+OrderProfit()+OrderSwap();b=b+1;    
      }
    } 
  }
  
  bsum=MathRound(bsum);
  ssum=MathRound(ssum);
  summa=ssum+bsum;

  if ( summa<0 && pros>summa ) pros=summa;

  if ( s+b==2 ) pflag=1;

  if ( pflag==1 && s+b==1 && prof==0) prof=3*stop;
  if ( s+b==1 && prof==0 && fr) { prof=(2*stop+50);fr=false; }
 
  if (s+b==0) 
  { 
      blok=0;plb=0;pls=0;pl=0;prof=0;pflag=0;hblok=0;pros=0; 
  }
 
  if ( (wprnul>zbwpr && wprnul<zswpr) || (wprone<(swpr-15) && wprnul>(swpr-15)) || 
       (wprone>(bwpr+15) && wprnul<(bwpr+15)) || (ccione>-100 && ccinul<-100) || (ccione<100 && ccinul>100)) sig=1; 
       
  if (blok==1) sig=0;
  
  Comment("Account  = ",number,"   FreeMargin=",MathRound(FreeMargin),"  Signal=",sig,"\n","WPR1=",wprone,
          "  WPR0=",wprnul,"  CCI1=",ccione,"  CCI0=",ccinul,"  Stop=",stop,"\n","Blok=",blok,"  HBlok=",hblok,
          "  Risk=",risk,"  SPros=",pros,"  SProf=",prof,"  Proofit=",summa);
 
  if ( summa<=-8*stop ) risk=1; else risk=0;
  
  if (s+b==1 && hblok==0 && risk==1)
   { 
  if ( FreeMargin<depo ) return(0);
  if ( summa<-8*stop && Open[0]>Close[0] && ccinul<ccione && wprone>-10 && wprnul<wprone )
   { 
  RefreshRates();
  tiket=OrderSend(Symbol(),OP_SELL,kh*mlot,Bid,5,Bid+StopLoss*Point,Bid-3*TakeProfit*Point,"HWPRLOK",MagicNumber,0,Red);
  Sleep(12000);
  if(tiket>0)
   {
     if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES))
   {       
     Print("HSell order opened : ",OrderOpenPrice());hblok=1;
   }
   }
     else Print("Error opening HSell order : ",GetLastError()); 
      hblok=1;
      return(0);
   } 
  if ( summa<-8*stop && Close[0]>Open[0] && ccinul>ccione && wprone<-90 && wprnul>wprone )
   {  
  RefreshRates();
  tiket=OrderSend(Symbol(),OP_BUY,kh*mlot,Ask,5,Ask-StopLoss*Point,Bid+3*TakeProfit*Point,"HWPRLOK",MagicNumber,0,Red);Sleep(12000);
  if(tiket>0)
   {
     if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES))
   {
     Print("HBuy order opened : ",OrderOpenPrice());hblok=1;
   }  
   }
     else Print("Error opening HBuy order : ",GetLastError());hblok=1;
     return(0);
   }
 } 
 
  if (wprnul<bwpr && s+b==2 && ssum>stop) pls=1; 
  if (ssum>=3*stop*mlot) pls=1;
  
  if( pls==1 && hblok==0 )
   { 
    ttr=OrdersTotal()-1;
    for(cnt=ttr;cnt>=0 ;cnt--)
     {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
       if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber() == MagicNumber )
        {   
         prof=prof+OrderProfit();           
         RefreshRates();
         OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
         Sleep(12000);
         return(0);
        }
     }
   } 
   
  if (wprnul>swpr && s+b==2 && bsum>stop) plb=1;
  if (bsum>=3*stop*mlot) plb=1;

  if( plb==1 && hblok==0 )
   { 
    ttr=OrdersTotal()-1;
    for(cnt=ttr;cnt>=0 ;cnt--)
     {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
       if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber() == MagicNumber )
        {      
         prof=prof+OrderProfit();        
         RefreshRates();
         OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
         Sleep(12000);
         return(0);
        }
     }
   } 
  
  prof=MathRound(prof);
  
  if (s+b==1 && summa>=stop && prof==0) pl=1;
  if ( prof>0 && summa<0 && (prof-MathAbs(summa))>=stop*mlot && s+b==1 && hblok==0 ) pl=1;
  if ( summa+prof>6*stop && s+b==1 && hblok==0 ) pl=1;
  if ((pros<-0.3*depo) && ((summa+prof)>0.3*pros) && s+b==1 && hblok==0 ) pl=1;
  if ( hblok==1 && s+b>0 && (summa>=stop*mlot) ) pl=1;
  if ( (summa+prof)>4*stop*mlot ) pl=1;
  if ( prof<stop && summa>0 && s+b==1) pl=1; 
  if (pros<-10*stop && (summa+prof)>-5*stop && hblok==0) pl=1; 
       
  if ( pl==1 )
  { 
   ttr=OrdersTotal()-1;
   for(cnt=ttr;cnt>=0 ;cnt--)
    {
     if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {
       if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber() == MagicNumber )
        {   
         prof=prof+OrderProfit();           
         RefreshRates();
         OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
         Sleep(12000);
         return(0);
        } 
       if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber() == MagicNumber )
        { 
         prof=prof+OrderProfit();
         RefreshRates();
         OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
         Sleep(12000);
         return(0);
        }
      }
    } 
  }
 
 if ( FreeMargin<MathRound(depo/2) ) return(0);
 
 if ( s+b<=1 && blok==0 ) 
  {
 if ( FreeMargin<MathRound(depo/4) ) return(0);
  
 if ( DWeek==5 && STime>=18 ) return(0);

 
 if ( (s==0 && sig==1) || (wprone>swpr && wprnul<wprone && b==1 && s==0) ) 
  {
    AN=CurTime();
    ObjectCreate(AN, OBJ_ARROW, 0, Time[0], High[0]+10*Point);
    ObjectSet(AN, OBJPROP_ARROWCODE, 242);
    ObjectSet(AN, OBJPROP_COLOR , Gold);
    RefreshRates();
    tiket=OrderSend(Symbol(),OP_SELL,mlot,Bid,5,Bid+StopLoss*Point,Bid-TakeProfit*Point,"WPRLok01s",MagicNumber,0,Lime);
    Sleep(12000);
 if(tiket>0)
   {
     if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES))
   {
     Print("Sell order opened : ",OrderOpenPrice()); 
   }  
   }
     else Print("Error opening Sell order : ",GetLastError()); 
    return(0);
  }
 
 if ( (b==0 && sig==1) || (wprone<bwpr && wprnul>wprone && s==1 && b==0) ) 
  {
    AN=CurTime();
    ObjectCreate(AN, OBJ_ARROW, 0, Time[0], Low[0]-10*Point);
    ObjectSet(AN, OBJPROP_ARROWCODE, 241);
    ObjectSet(AN, OBJPROP_COLOR , Lime);
    blok=1; sig=0; 
    RefreshRates();
    tiket=OrderSend(Symbol(),OP_BUY,mlot,Ask,5,Ask-StopLoss*Point,Ask+TakeProfit*Point,"WPRLok01b",MagicNumber,0,Gold);
    Sleep(12000);
 if(tiket>0)
   {
     if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES))
   {       
     Print("Buy order opened : ",OrderOpenPrice()); 
   }
   }
     else Print("Error opening Buy order : ",GetLastError()); 
    return(0);
  }
   }
  
//----
   return(0);
  }
//+------------------------------------------------------------------+